<template>
  <!-- <headers title="我的班级" /> -->
  <view class="class-container">
    <u-tabs
      :list="tabsState.list"
      :is-scroll="false"
      v-model="tabsState.current"
      :active-item-style="{ fontSize: '34rpx', color: '#000000' }"
      font-size="28"
      bar-width="72"
      bar-height="6"
      bg-color="#fbfcff"
      inactive-color="#cecfcf"
      active-color="#05a8ff"
      @change="tabsChange"
    />
    <!-- 搜索 -->
    <uni-search-bar
      placeholder="班级名称"
      bgColor="#ffffff"
      clearButton="auto"
      cancelButton="none"
      @confirm="search"
      @clear="clear"
    />
    <!-- 内容 -->
    <view v-if="classList.length">
      <text class="fund">为你找到{{ listQuery.total }}个的班级</text>

      <block v-for="(item, index) in classList" :key="index">
        <classItem :classItem="item" :current="tabsState.current" />
      </block>
      <view v-if="tabsState.current" style="padding: 20rpx">
        <u-loadmore :status="status" icon-type="flower" />
      </view>
    </view>
    <u-empty
      v-else
      text="暂无数据~"
      icon-size="506"
      :margin-top="220"
      src="../../static/img/noData.png"
    ></u-empty>
  </view>
</template>

<script setup lang="ts">
// import headers from "@/components/header/index.vue"
import classItem from "./components/classItem.vue";
import { getClassDetail } from "@/api/class";
import { useGlobalStore } from "@/store/useStore";

const globalStore = useGlobalStore();

const tabsState = reactive({
  list: [
    {
      name: "进行中",
    },
    {
      name: "未开课",
    },
    {
      name: "已结课",
    },
  ],
  current: 0,
});

const classList = ref([] as any);

const listQuery = reactive({
  Phone: globalStore.infoData.FMOBILE,
  studentId: globalStore.infoData.FSTUDENTID,
  pageIndex: 1,
  pageSize: 10,
  total: 0,
  type: 0,
  Name: "",
});

const status = ref("loadmore");

const tabsChange = (index: number) => {
  classList.value = [];
  switch (index) {
    case 0:
      listQuery.type = 0;
      break;
    case 1:
      listQuery.type = 1;
      break;
    default:
      listQuery.type = 2;
      break;
  }
  init();
};

const search = (val: any) => {
  listQuery.Name = val.value;
  tabsChange(tabsState.current);
};

const clear = () => {
  listQuery.Name = "";
  tabsChange(tabsState.current);
};

// 上拉加载数据
onReachBottom(() => {
  // 判断是否还有下一页数据
  if (listQuery.pageIndex * listQuery.pageSize >= listQuery.total)
    return (status.value = "nomore");
  // // 判断是否正在请求其它数据，如果是，则不发起额外的请求
  if (status.value === "loading") return;
  listQuery.pageIndex += 1;
  init();
});

const init = async () => {
  status.value = "loading";
  const { data: res } = await getClassDetail(listQuery);
  if (res.code == 200) {
    if (res.total > 10) status.value = "loadmore";
    else status.value = "nomore";
    classList.value = [...classList.value, ...res.data];
    listQuery.total = res.total;
    // console.log(classList.value);
  }
};

onShow(() => {
  classList.value = [];
  listQuery.pageIndex = 1;
  listQuery.pageSize = 10;
  init();
});
</script>

<style lang="scss" scoped>
.class-container {
  padding: 0 30rpx 30rpx;
}
</style>
